gmap = context

map_type = 'map.setMapType(G_MAP_TYPE);'
if gmap.mapType == 'satellite':
    map_type = 'map.setMapType(G_SATELLITE_TYPE);'

map_control = ''
if gmap.mapControl == 'large':
    map_control = 'map.addControl(new GLargeMapControl());'
elif gmap.mapControl == 'small':
    map_control = 'map.addControl(new GSmallMapControl());'

type_control = ''
if gmap.typeControl:
    type_control = 'map.addControl(new GMapTypeControl());'

portal_url = context.portal_url()

print '''<div id="map" style="position: relative; height: %spx"></div>
<script type="text/javascript">
//<![CDATA[
window.onload = function create_gmap() {
  if (GBrowserIsCompatible()) {
    // Create marker icon
    var icon = new GIcon();
    icon.image = "%s/gmap_marker.png";
    icon.shadow = "%s/gmap_shadow.png";
    icon.iconSize = new GSize(20, 34);
    icon.shadowSize = new GSize(37, 34);
    icon.iconAnchor = new GPoint(9, 34);
    icon.infoWindowAnchor = new GPoint(9, 2);
    icon.infoShadowAnchor = new GPoint(18, 25);
''' % (gmap.height, portal_url, portal_url)

print '''
    var map = new GMap(document.getElementById("map"));
    %s
    %s
    %s
    map.centerAndZoom(new GPoint(%f, %f), %d);
''' % (map_type, map_control, type_control, gmap.longitude, gmap.latitude, gmap.zoom)

gmarkers = gmap.objectValues(['GMarker',])
if len(gmarkers) > 0:
    print '''
    // Create markers and events
    function createMarker(point, html) {
      var marker = new GMarker(point, icon);

      GEvent.addListener(marker, "click", function() {
        marker.openInfoWindowHtml(html);
      });
      return marker;
    }
'''
    for i in range(len(gmarkers)):
        gmarker = gmarkers[i]
        print '''
   addGMarker(%d,%f,%f);
''' % (i + 1, gmarker.longitude, gmarker.latitude)

print '''
  }
  function addGMarker(markerNo, lng, lat){
    var point = new GPoint(lng, lat)
    var marker = new GMarker(point, icon);
    var f = function(){
      map.centerAtLatLng(point);
      marker.openInfoWindowHtml(document.getElementById('marker_html_' + markerNo).innerHTML);
    };
    GEvent.addListener(marker, 'click', f);
    var marker_field = document.getElementById('marker_link_'+ markerNo);
    if(marker_field){
      marker_field.onmousedown = f;
    }
    map.addOverlay(marker);
  }
}
//]]>
</script>'''

return printed
